package cn.com.infosec.util.base64;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

public abstract class MyCharacterDecoder {
   protected abstract int bytesPerAtom();

   protected abstract int bytesPerLine();

   protected void decodeBufferPrefix(InputStream inputstream, OutputStream outputstream) {
   }

   protected void decodeBufferSuffix(InputStream inputstream, OutputStream outputstream) {
   }

   protected int decodeLinePrefix(InputStream inputstream, OutputStream outputstream) {
      return this.bytesPerLine();
   }

   protected void decodeLineSuffix(InputStream inputstream, OutputStream outputstream) {
   }

   protected void decodeAtom(InputStream inputstream, OutputStream outputstream, int i) {
      throw new StreamExhausted();
   }

   protected int readFully(InputStream inputstream, byte[] abyte0, int i, int j) {
      for(int var6 = 0; var6 < j; ++var6) {
         int var5;
         if ((var5 = inputstream.read()) == -1) {
            if (var6 == 0) {
               var6 = -1;
            }

            return var6;
         }

         int var10001 = var5;
         var5 = var6 + i;
         abyte0[var5] = (byte)var10001;
      }

      return j;
   }

   public void decodeBuffer(InputStream inputstream, OutputStream outputstream) {
      this.decodeBufferPrefix(inputstream, outputstream);

      label64:
      while(true) {
         int var10000;
         boolean var10001;
         try {
            var10000 = this.decodeLinePrefix(inputstream, outputstream);
         } catch (StreamExhausted var12) {
            var10001 = false;
            break;
         }

         int var3 = var10000;
         int var4 = 0;

         while(true) {
            int var14;
            try {
               var10000 = var4;
               var14 = this.bytesPerAtom();
            } catch (StreamExhausted var9) {
               var10001 = false;
               break label64;
            }

            if (var10000 + var14 >= var3) {
               try {
                  var10000 = var4;
                  var14 = this.bytesPerAtom();
               } catch (StreamExhausted var8) {
                  var10001 = false;
                  break label64;
               }

               if (var10000 + var14 == var3) {
                  try {
                     this.decodeAtom(inputstream, outputstream, this.bytesPerAtom());
                     this.bytesPerAtom();
                  } catch (StreamExhausted var7) {
                     var10001 = false;
                     break label64;
                  }
               } else {
                  MyCharacterDecoder var13 = this;
                  InputStream var16 = inputstream;
                  OutputStream var10002 = outputstream;
                  int var10003 = var3 - var4;

                  try {
                     var13.decodeAtom(var16, var10002, var10003);
                  } catch (StreamExhausted var6) {
                     var10001 = false;
                     break label64;
                  }
               }

               try {
                  this.decodeLineSuffix(inputstream, outputstream);
                  break;
               } catch (StreamExhausted var5) {
                  var10001 = false;
                  break label64;
               }
            }

            MyCharacterDecoder var15;
            try {
               var10000 = var4;
               var15 = this;
               this.decodeAtom(inputstream, outputstream, this.bytesPerAtom());
               this.bytesPerAtom();
            } catch (StreamExhausted var11) {
               var10001 = false;
               break label64;
            }

            try {
               var14 = var15.bytesPerAtom();
            } catch (StreamExhausted var10) {
               var10001 = false;
               break label64;
            }

            var4 = var10000 + var14;
         }
      }

      this.decodeBufferSuffix(inputstream, outputstream);
   }

   public byte[] decodeBuffer(String s) {
      MyCharacterDecoder var10000 = this;
      byte[] var2 = s.getBytes();
      ByteArrayInputStream var10001 = new ByteArrayInputStream(var2);
      ByteArrayOutputStream var3;
      var3 = new ByteArrayOutputStream.<init>();
      var10000.decodeBuffer(var10001, var3);
      return var3.toByteArray();
   }

   public byte[] decodeBuffer(InputStream inputstream) {
      MyCharacterDecoder var10000 = this;
      ByteArrayOutputStream var2;
      var2 = new ByteArrayOutputStream.<init>();
      var10000.decodeBuffer(inputstream, var2);
      return var2.toByteArray();
   }
}
